/*
** ---------------------------------------------------------------------------
** SVN Repository ...: $HeadURL: file:///Data/_Privat/Programmieren/Source-Repository/SVN/BeanDocument/trunk/src/net/beandocument/BeanObjectElement.java $
** Author ...........: $LastChangedBy: jscheffl $
** Modified .........: $LastChangedDate: 2005-02-27 15:11:14 +0100 (So, 27 Feb 2005) $
** Revision .........: $LastChangedRevision: 11 $
** Responsible ......: Jens Scheffler
** Initial version ..: Jens Scheffler
** ---------------------------------------------------------------------------
*/
package beandocument;

import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import net.beandocument.BeanDocumentBuilder;

import org.w3c.dom.Document;

/**
 * Sample Implementation to Convert all Java System Properties to XML
 * @author Jens Scheffler
 */
public class SystemProperties2XML {

    /**
     * Main Runnable Entry Method
     * @param args Command line arguments - not required/ignored for this implementation
     */
    public static void main(String[] args) {
        Object xmlSource = System.getProperties();
        
        try {
            BeanDocumentBuilder beanBuilder = new BeanDocumentBuilder();
            beanBuilder.setMaxDepth(2);
            Document xml = beanBuilder.getDocument(xmlSource);
            TransformerFactory tf = TransformerFactory.newInstance();
            Transformer t = tf.newTransformer();
            t.transform(new DOMSource(xml), new StreamResult(System.out));
        } catch (Exception e) {
            System.err.println("Error during transformation: " + e);
            e.printStackTrace();
        }
    }
}
