/*
** ---------------------------------------------------------------------------
** SVN Repository ...: $HeadURL: file:///Data/_Privat/Programmieren/Source-Repository/SVN/BeanDocument/trunk/test/net/beandocument/BeanDocumentTest.java $
** Author ...........: $LastChangedBy: jscheffl $
** Modified .........: $LastChangedDate: 2005-02-27 15:11:14 +0100 (So, 27 Feb 2005) $
** Revision .........: $LastChangedRevision: 11 $
** Responsible ......: Jens Scheffler
** Initial version ..: Jens Scheffler
** ---------------------------------------------------------------------------
*/
package net.beandocument;

import junit.framework.TestCase;

import org.w3c.dom.DOMException;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

/**
 * Test Case for BeanBaseNode class.
 * @author Jens Scheffler
 */
public class BeanBaseNodeTest extends TestCase {
    
    /**
     * Node implementation to test base class
     * @author jscheffl
     */
    private class NodeImpl extends BeanBaseNode {

        /**
         * @param owner
         * @param parent
         */
        protected NodeImpl(BeanDocument owner, BeanBaseNode parent) {
            super(owner, parent);
        }

        /**
         * @return
         * @see org.w3c.dom.Node#getNodeType()
         */
        public short getNodeType() {
            return 0;
        }

        /**
         * @return
         * @see org.w3c.dom.Node#hasAttributes()
         */
        public boolean hasAttributes() {
            return false;
        }

        /**
         * @return
         * @see org.w3c.dom.Node#hasChildNodes()
         */
        public boolean hasChildNodes() {
            return false;
        }

        /**
         * @return
         * @see org.w3c.dom.Node#getLocalName()
         */
        public String getLocalName() {
            return null;
        }

        /**
         * @return
         * @see org.w3c.dom.Node#getNodeName()
         */
        public String getNodeName() {
            return null;
        }

        /**
         * @return
         * @throws DOMException
         * @see org.w3c.dom.Node#getNodeValue()
         */
        public String getNodeValue() throws DOMException {
            return null;
        }

        /**
         * @return
         * @see org.w3c.dom.Node#getAttributes()
         */
        public NamedNodeMap getAttributes() {
            return null;
        }

        /**
         * @return
         * @see org.w3c.dom.Node#getFirstChild()
         */
        public Node getFirstChild() {
            return null;
        }

        /**
         * @return
         * @see org.w3c.dom.Node#getLastChild()
         */
        public Node getLastChild() {
            return null;
        }

        /**
         * @return
         * @see org.w3c.dom.Node#getChildNodes()
         */
        public NodeList getChildNodes() {
            return null;
        }
    }

    private BeanElementFactory ef;
    private BeanDocument doc;
    private NodeImpl impl;
    
    /**
     * @see TestCase#setUp()
     */
    protected void setUp() throws Exception {
        ef = new BeanElementFactory();
        doc = new BeanDocument(ef, this);
        impl = new NodeImpl(doc, doc);
    }

    /**
     * A Test Case
     */
    public final void testAppendChild() {
        try {
            impl.appendChild(doc);
        } catch (DOMException e) {
            return;
        }
        assertTrue(false);
    }

    /**
     * A Test Case
     */
    public final void testCloneNode() {
        try {
            impl.cloneNode(false);
        } catch (IllegalArgumentException e) {
            return;
        }
        assertTrue(false);
    }

    /**
     * A Test Case
     */
    public final void testGetNamespaceURI() {
        assertNull(impl.getNamespaceURI());
    }

    /**
     * A Test Case
     */
    public final void testGetPrefix() {
        assertNull(impl.getPrefix());
    }

    /**
     * A Test Case
     */
    public final void testInsertBefore() {
        try {
            impl.insertBefore(null, null);
        } catch (DOMException e) {
            return;
        }
        assertTrue(false);
    }

    /**
     * A Test Case
     */
    public final void testIsSupported() {
        assertFalse(impl.isSupported(null, null));
    }

    /**
     * A Test Case
     */
    public final void testNormalize() {
        impl.normalize();
    }

    /**
     * A Test Case
     */
    public final void testGetOwnerDocument() {
        assertEquals(doc, impl.getOwnerDocument());
    }

    /**
     * A Test Case
     */
    public final void testRemoveChild() {
        try {
            impl.removeChild(null);
        } catch (DOMException e) {
            return;
        }
        assertTrue(false);
    }

    /**
     * A Test Case
     */
    public final void testReplaceChild() {
        try {
            impl.replaceChild(null, null);
        } catch (DOMException e) {
            return;
        }
        assertTrue(false);
    }

    /**
     * A Test Case
     */
    public final void testSetNodeValue() {
        try {
            impl.setNodeValue("test");
        } catch (DOMException e) {
            return;
        }
        assertTrue(false);
    }

    /**
     * A Test Case
     */
    public final void testSetPrefix() {
        try {
            impl.setPrefix("test");
        } catch (DOMException e) {
            return;
        }
        assertTrue(false);
    }

    /**
     * A Test Case
     */
    public final void testGetElementFactory() {
        assertEquals(ef, impl.getElementFactory());
    }

    /**
     * A Test Case
     */
    public final void testGetPreviousSibling() {
        assertNull(impl.getPreviousSibling());
        impl.setPreviousSibling(impl);
        assertEquals(impl, impl.getPreviousSibling());
    }

    /**
     * A Test Case
     */
    public final void testGetNextSibling() {
        assertNull(impl.getNextSibling());
        impl.setNextSibling(impl);
        assertEquals(impl, impl.getNextSibling());
    }

    /**
     * A Test Case
     */
    public final void testSetNextSibling() {
        assertNull(impl.getNextSibling());
        impl.setNextSibling(impl);
        assertEquals(impl, impl.getNextSibling());
    }

    /**
     * A Test Case
     */
    public final void testSetPreviousSibling() {
        assertNull(impl.getPreviousSibling());
        impl.setPreviousSibling(impl);
        assertEquals(impl, impl.getPreviousSibling());
    }

    /**
     * A Test Case
     */
    public final void testGetParentNode() {
        assertEquals(doc, impl.getParentNode());
    }
}
