/*
** ---------------------------------------------------------------------------
** SVN Repository ...: $HeadURL: file:///Data/_Privat/Programmieren/Source-Repository/SVN/BeanDocument/trunk/src/net/beandocument/BeanDocumentFragment.java $
** Author ...........: $LastChangedBy: jscheffl $
** Modified .........: $LastChangedDate: 2005-02-27 15:11:14 +0100 (So, 27 Feb 2005) $
** Revision .........: $LastChangedRevision: 11 $
** Responsible ......: Jens Scheffler
** Initial version ..: Jens Scheffler
** ---------------------------------------------------------------------------
*/
package net.beandocument;

import org.w3c.dom.Node;

import junit.framework.TestCase;

/**
 * Test Case for BeanDocumentFragment class.
 * @author Jens Scheffler
 */
public class BeanDocumentFragmentTest extends TestCase {

    private BeanDocumentFragment f;
    private BeanDocument doc;
    
    /**
     * @see TestCase#setUp()
     */
    protected void setUp() throws Exception {
        doc = new BeanDocument(new BeanElementFactory(), this);
        f = new BeanDocumentFragment(doc);
    }

    /**
     * A Test Case
     */
    public final void testGetNodeType() {
        assertEquals(Node.DOCUMENT_FRAGMENT_NODE, f.getNodeType());
    }

    /**
     * A Test Case
     */
    public final void testHasAttributes() {
        assertFalse(f.hasAttributes());
    }

    /**
     * A Test Case
     */
    public final void testHasChildNodes() {
        assertFalse(f.hasChildNodes());
    }

    /**
     * A Test Case
     */
    public final void testGetLocalName() {
        assertEquals("#document-fragment", f.getLocalName());
    }

    /**
     * A Test Case
     */
    public final void testGetNodeName() {
        assertEquals("#document-fragment", f.getNodeName());
    }

    /**
     * A Test Case
     */
    public final void testGetNodeValue() {
        assertNull(f.getNodeValue());
    }

    /**
     * A Test Case
     */
    public final void testGetAttributes() {
        assertNull(f.getAttributes());
    }

    /**
     * A Test Case
     */
    public final void testGetFirstChild() {
        assertNull(f.getFirstChild());
    }

    /**
     * A Test Case
     */
    public final void testGetLastChild() {
        assertNull(f.getLastChild());
    }

    /**
     * A Test Case
     */
    public final void testGetChildNodes() {
        assertNotNull(f.getChildNodes());
        assertTrue(f.getChildNodes() instanceof BeanNodeList);
        assertEquals(0, f.getChildNodes().getLength());
    }
}
