/*
** ---------------------------------------------------------------------------
** SVN Repository ...: $HeadURL: file:///Data/_Privat/Programmieren/Source-Repository/SVN/BeanDocument/trunk/src/net/beandocument/BeanCollectionElement.java $
** Author ...........: $LastChangedBy: jscheffl $
** Modified .........: $LastChangedDate: 2005-02-27 15:11:14 +0100 (So, 27 Feb 2005) $
** Revision .........: $LastChangedRevision: 11 $
** Responsible ......: Jens Scheffler
** Initial version ..: Jens Scheffler
** ---------------------------------------------------------------------------
*/
package net.beandocument;

import junit.framework.TestCase;

/**
 * Test Case for BeanNodeList class.
 * @author Jens Scheffler
 */
public class BeanNodeListTest extends TestCase {

    private BeanNodeList nl;

    /**
     * @see TestCase#setUp()
     */
    protected void setUp() throws Exception {
        super.setUp();

        BeanDocument doc = new BeanDocument(new BeanElementFactory(), this);
        BeanElement owner = new BeanSimpleTypeElement(doc, doc, "test", this);
        BeanAttribute attr1 = new BeanAttribute(doc, owner, "name1", "value1");
        BeanAttribute attr2 = new BeanAttribute(doc, owner, "name2", "value2");
        BeanAttribute attr3 = new BeanAttribute(doc, owner, "name3", "value3");
        nl = new BeanNodeList();
        nl.add(attr1);
        nl.add(attr2);
        nl.add(attr3);
    }

    /**
     * A Test Case
     */
    public final void testGetLength() {
        assertEquals(3, nl.getLength());
    }

    /**
     * A Test Case
     */
    public final void testItem() {
        assertTrue(nl.item(0) instanceof BeanAttribute);
        assertTrue(nl.item(1) instanceof BeanAttribute);
        assertTrue(nl.item(2) instanceof BeanAttribute);
        try {
            nl.item(3);
        } catch (ArrayIndexOutOfBoundsException e) {
            return;
        }
        assertTrue(false);
    }

    /**
     * A Test Case
     */
    public final void testAdd() {
        BeanDocument doc = new BeanDocument(new BeanElementFactory(), this);
        BeanElement owner = new BeanSimpleTypeElement(doc, doc, "test", this);
        BeanAttribute attr = new BeanAttribute(doc, owner, "name", "value");
        assertEquals(3, nl.getLength());
        nl.add(attr);
        assertEquals(4, nl.getLength());
    }
}
