/*
** ---------------------------------------------------------------------------
** SVN Repository ...: $HeadURL: file:///Data/_Privat/Programmieren/Source-Repository/SVN/BeanDocument/trunk/src/net/beandocument/BeanCollectionElement.java $
** Author ...........: $LastChangedBy: jscheffl $
** Modified .........: $LastChangedDate: 2005-02-27 15:11:14 +0100 (So, 27 Feb 2005) $
** Revision .........: $LastChangedRevision: 11 $
** Responsible ......: Jens Scheffler
** Initial version ..: Jens Scheffler
** ---------------------------------------------------------------------------
*/
package net.beandocument;

import junit.framework.TestCase;

/**
 * Test Case for BeanSimpleTypeElement class.
 * @author Jens Scheffler
 */
public class BeanSimpleTypeElementTest extends TestCase {

    private BeanSimpleTypeElement stringEl;
    private BeanSimpleTypeElement intEl;
    private BeanSimpleTypeElement longEl;
    private BeanSimpleTypeElement byteEl;
    private BeanSimpleTypeElement charEl;
    private BeanElement owner;
    private BeanDocument doc;

    /**
     * @see TestCase#setUp()
     */
    protected void setUp() throws Exception {
        super.setUp();
        
        BeanElementFactory ef = new BeanElementFactory();
        ef.setMaxDepth(5);
        doc = new BeanDocument(ef, this);
        owner = new BeanSimpleTypeElement(doc, doc, "test", this);
        String s = "test";
        stringEl = new BeanSimpleTypeElement(doc, owner, "test", s);
        int i = 35;
        intEl = new BeanSimpleTypeElement(doc, owner, "test", new Integer(i));
        long l = 77;
        longEl = new BeanSimpleTypeElement(doc, owner, "test", new Long(l));
        byte[] b = "test".getBytes();
        Byte[] ob = new Byte[b.length];
        for (int j = 0; j < b.length; j++) {
            ob[j] = new Byte(b[j]);
        }
        byteEl = new BeanSimpleTypeElement(doc, owner, "test", ob);
        char[] c = "test".toCharArray();
        Character[] oc = new Character[c.length];
        for (int j = 0; j < c.length; j++) {
            oc[j] = new Character(c[j]);
        }
        charEl = new BeanSimpleTypeElement(doc, owner, "test", oc);
    }

    /**
     * A Test Case
     */
    public final void testGetChildNodes() {
        assertEquals(1, stringEl.getChildNodes().getLength());
        assertEquals(1, intEl.getChildNodes().getLength());
        assertEquals(1, longEl.getChildNodes().getLength());
        assertEquals(1, byteEl.getChildNodes().getLength());
        assertEquals(1, charEl.getChildNodes().getLength());
        assertNotNull(stringEl.getChildNodes().item(0));
        assertNotNull(intEl.getChildNodes().item(0));
        assertNotNull(longEl.getChildNodes().item(0));
        assertNotNull(byteEl.getChildNodes().item(0));
        assertNotNull(charEl.getChildNodes().item(0));
        assertEquals("test", stringEl.getChildNodes().item(0).getNodeValue());
        assertEquals("35", intEl.getChildNodes().item(0).getNodeValue());
        assertEquals("77", longEl.getChildNodes().item(0).getNodeValue());
        assertEquals("test", byteEl.getChildNodes().item(0).getNodeValue());
        assertEquals("test", charEl.getChildNodes().item(0).getNodeValue());
    }
}
